/*
  header file of the program
*/

#ifndef O2D_H
#define O2D_H

namespace Ns
{

// *******************
struct Tfile
{
    uint                file_number;
    Tauto_array<char>   file_name;

    FILE                *fi;
    uint                first_src_line;

    //line offsets from first_src_line
    list<uint>          line_pos;
    uint                line_pos_size;

    uint        find_line_pos(const uint src_line);

    Tfile(const uint fn=0, FILE *ft=0):
        file_number(fn),
        fi(ft),
        first_src_line(0),
        line_pos_size(0)
     {}
};

// *******************
struct Tline
{
    //line with ".loc File Line"
    uint    asm_line_number;

    uint    src_file_number;
    uint    src_line_number;
    //
    char    is_src_not_in_order;

    Tline(
          const uint al=0,
          const uint sf=0,
          const uint sl=0,
          const char no=0
         ):
            asm_line_number(al),
            src_file_number(sf),
            src_line_number(sl),
            is_src_not_in_order(no)
     {}
};

//namespace Ns
}

#endif

